#!/usr/bin/perl -w


  use warnings;
  use strict;
  use subprogramEM;

# if $direct_par_def = 1 all parameters except input folder are defined in the program; 
# if $direct_par_def = 0 set_file is read and the user is asked if the settings are correct and can change them
# parameters non_visibles (data2 is produced by pipe1.pl)
# if $direct_par_def = 2 the set_file is read and the user cannot change the parameters (option for running behind a windows interface)
my $direct_par_def = 0;
my $set_file = 'set_pipe2.txt';

#my $trans_file = 'motifs_transmot_hach1_6.txt';
#my %motif_t = ();

# parameters read from file
my $del_files = '';
my $blast_path = '';
my $clust_path = '';
my $clust_ver = '';
my $gr_limit = '';
my $min1 = '';
my $min2 = '';
my $min3 = '';
my $min4 = '';
my $min5 = '';
my $min6 = '';
my $E_blast = '';
my $syst = '';
my $folder = '';
my $prop_maj = '';
my $cons_calc = 1;




if ($direct_par_def == 1)
{
	$del_files = 1;
	$blast_path = '/home/user0/bin/blast-2.2.19/bin/';
#	$blast_path = 'c:/BLAST2_2_18/bin/';
#	$clust_path = 'c:/CLUSTALW/clustalw1.83.XP/';
	$clust_path = '/home/user0/bin/clustalw-2.0.10/';
	$clust_ver = 2;
	$gr_limit = 0.05;
	$min1 = 8;
	$min2 = 4;
	$min3 = 4;
	$min4 = 4;
	$min5 = 4;
	$min6 = 4;
	$E_blast = '1E-40';
	$syst = 'linux';
	$folder = 'sample';
	$prop_maj = 0.66;
	$cons_calc = 1;

}
elsif ($direct_par_def == 0)
{
print "**********************************************************\n";
print "QDD version1.2 22 February 2010\n";
print "Emese Meglecz, Aix-Marseille University, Marseille, France\n";
print 'emese.meglecz@univ-provence.fr';
print "\n";
print "Plesae, read the Documentation_QDD.pdf\n";
print "**********************************************************\n";

    param_input($set_file,\$del_files,\$blast_path,\$clust_path,\$clust_ver,\$gr_limit,\$min1,\$min2,\$min3,\$min4,\$min5,\$min6,\$E_blast,\$syst,\$folder,\$prop_maj,\$cons_calc);
}
else
{

    open(SET, $set_file);
    my @setings = <SET>;

    $del_files = $setings[0];
    chomp $del_files;
    $blast_path = $setings[1];
    chomp $blast_path;
    $clust_path = $setings[2];
    chomp $clust_path;
    $clust_ver = $setings[3];
    chomp $clust_ver;
    $gr_limit = $setings[4];
    chomp $gr_limit;
    $min1 = $setings[5];
    chomp $min1;
    $min2 = $setings[6];
    chomp $min2;
    $min3 = $setings[7];
    chomp $min3;
    $min4 = $setings[8];
    chomp $min4;
    $min5 = $setings[9];
    chomp $min5;
    $min6 = $setings[10];
    chomp $min6;
    $E_blast = $setings[11];
    chomp $E_blast;
    $syst = $setings[12];
    chomp $syst;
    $folder = $setings[13];
    chomp $folder;
    $prop_maj = $setings[14];
    chomp $prop_maj;
    $cons_calc = $setings[15];
    chomp $cons_calc;

 
    close SET;
	
  	open(OLDOUT, ">&STDOUT");
  	open(OLDERR, ">&STDERR");
  	open(STDOUT, "> logfile.log") or die "Can't open STDOUT to logfile $!\n";
		open(STDERR, ">> errors.log") or die "Can't open STDERR to logfile $!\n";
}

# check if '\' or '/'is present at the end of the prorgam path and add if it it missing
check_path(\$blast_path, $syst);
check_path(\$clust_path, $syst);


print "del_files = $del_files\nblast_path = $blast_path\nclust_path = $clust_path\nclust_ver = $clust_ver\n";
print "gr_limit = $gr_limit\nmin1 = $min1\nmin2 = $min2\nmin3 = $min3\nmin4 = $min4\nmin5 = $min5\nmin6 = $min6\n";
print "E_blast = $E_blast\nsystem = $syst\nfolder = $folder\nprop_maj = $prop_maj\ncons_calc = $cons_calc\n";

##################
##################
##################
# to make windows fans happy to be able to use file names with spaces in it
# copy input files into c:\QDD_tetetemp
my $make_folder = '';
my $copy = '';
my $orig_folder = $folder;
if ($syst eq 'win')
{
#DO NOT FIDDLE WITH THIS LINE!!!!! IT DELETES A FOLDER WITHOUT ASKING FOR COMFIRMATION
	check_and_delete_folder('c:\QDD_tetetemp');

	$make_folder = 'md c:\QDD_tetetemp\data2';
	system $make_folder;

	my $data2 = $orig_folder.'\\data2';
	unless ( opendir(FOLDER, $data2) )
	{
   	   print "Cannot access to folder $data2\n";
  	    exit;
	}
	my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);


	foreach my $file (@files)
	{
		my $orig_file = $file;
		$file =~ s/\s/_/g;
		my $rename = 'ren "'.$folder.'\\data2\\'.$orig_file.'" '.$file;
		system $rename;
		$copy = 'copy "'.$folder.'\\data2\\'.$file.'" c:\QDD_tetetemp\\data2\\';
		system $copy; 	
	}

	$folder = 'c:\QDD_tetetemp';
	
}
##################
##################
##################



unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @folder_files = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

my @data3 = ('data3');
check_and_rename_folder(\@data3, \@folder_files, $folder, $syst);

my $folder_data2 = '';
my $make_folder = ''; 
if ($syst eq 'win')
{
    $folder_data2 = $folder.'\\data2';
	$make_folder = 'md '.$folder.'\\data3';
	system $make_folder;
}
elsif ($syst eq 'linux')
{
    $folder_data2 = $folder.'/data2';
#    print "$folder_data2\n";
	$make_folder = 'mkdir '.$folder.'/data3';
	system $make_folder;
}

unless ( opendir(FOLDER, $folder_data2) )
  {
      print "Cannot access to folder $folder_data2\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);


# check if no folder exist with the smae name as the files to be analised (WO extesion)
check_and_rename_folder(\@filenames, \@folder_files, $folder, $syst);



foreach my $file (sort @filenames)
{
	print "********** $file **********\n";
	$file =~ /.+?\./;
	my $tempfolder = $&;
	$tempfolder =~ s/\.//;
	my $outfolder = '';
	my $copy = '';
	if ($syst eq 'win')
	{
	    $outfolder = $folder.'\\'.$tempfolder;
		$make_folder = 'md '.$outfolder;
		system $make_folder;
		$copy = 'copy '.$folder_data2.'\\'.$file.' '.$outfolder.'\\';
		system $copy; 
	}
	elsif ($syst eq 'linux')
	{
	    $outfolder = $folder.'/'.$tempfolder;
		$make_folder = 'mkdir '.$outfolder;
		system $make_folder;
		$copy = 'cp '.$folder_data2.'/'.$file.' '.$outfolder.'/';
		system $copy; 
	}

   my $find_ms1 = 'perl find_and_mask_ms.pl '.$min1.' '.$min2.' '.$min3.' '.$min4.' '.$min5.' '.$min6.' 1 0 '.$outfolder.' '.$outfolder.' pipe2\.fas';
	print "\n$find_ms1\n";
   system $find_ms1;

	if ($syst eq 'linux')
	{
   my $group_seq1 = 'perl group_seq_var2.pl '.$E_blast.' '.$blast_path.' '.$syst.' '.$outfolder.' '.$outfolder.' _mask\.fas';
	print "\n$group_seq1\n";
  system $group_seq1;
	}
	elsif ($syst eq 'win')
	{
   my $group_seq1 = 'perl group_seq_var2.pl '.$E_blast.' "'.$blast_path.'\" '.$syst.' '.$outfolder.' '.$outfolder.' _mask\.fas';
	print "\n$group_seq1\n";
  system $group_seq1;
	}


if ($cons_calc == 0)
{
	my $use_unique = 'perl select_unique_only.pl '.$outfolder.' '.$outfolder.' _nr\.fas';
	print "\n$use_unique\n";
	system $use_unique;

	my $pipe3 = $outfolder;
	$pipe3 =~ s/pipe2/pipe3/;
	$pipe3 .= '.fas';

	if ($syst eq 'win')
	{
	    $pipe3 =~ s/.*\\//;
		$copy = 'copy '.$outfolder.'\\'.$pipe3.' '.$folder.'\\data3\\';
		system $copy; 
	}
	if ($syst eq 'linux')
	{
	    $pipe3 =~  s/.*\///;
		$copy = 'cp '.$outfolder.'/'.$pipe3.' '.$folder.'/data3/';
		system $copy; 
	}

}
else
{
   my $find_ms2 = 'perl find_and_mask_ms.pl '.$min1.' '.$min2.' '.$min3.' '.$min4.' '.$min5.' '.$min6.' 1 0 '.$outfolder.' '.$outfolder.' _nr\.fas';
	print "\n$find_ms2\n";
   system $find_ms2;

	if ($syst eq 'linux')
	{
   my $calc_ident = 'perl calc_ident2.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$blast_path.' '.$clust_path.' '.$clust_ver.' '.$E_blast.' 20 1 _nr.fas';
	print "\n$calc_ident\n";
   system $calc_ident;
	}
	elsif ($syst eq 'win')
	{
   my $calc_ident = 'perl calc_ident2.pl '.$syst.' '.$outfolder.' '.$outfolder.' "'.$blast_path.'\" "'.$clust_path.'\" '.$clust_ver.' '.$E_blast.' 20 1 _nr.fas';
	print "\n$calc_ident\n";
   system $calc_ident;
	}

   my $all_seq_gr_info = 'perl all_seq_gr_info2.pl '.$outfolder.' '.$outfolder.' '.$gr_limit.' _nr.fas';
	print "\n$all_seq_gr_info\n";
  system $all_seq_gr_info;

	if ($syst eq 'linux')
	{
   my $select_unique_make_cons = 'perl select_unique_make_cons.pl '.$outfolder.' '.$outfolder.' '.$syst.' '.$E_blast.' '.$blast_path.' '.$clust_path.' '.$clust_ver.' '.$prop_maj;
	print "\n$select_unique_make_cons\n";
   system $select_unique_make_cons;
	}
	elsif ($syst eq 'win')
	{
   my $select_unique_make_cons = 'perl select_unique_make_cons.pl '.$outfolder.' '.$outfolder.' '.$syst.' '.$E_blast.' "'.$blast_path.'\" "'.$clust_path.'\" '.$clust_ver.' '.$prop_maj;
	print "\n$select_unique_make_cons\n";
   system $select_unique_make_cons;
	}



# programs to identify 'unique'=no hit consensus sequences

   my $find_ms3 = 'perl find_and_mask_ms.pl '.$min1.' '.$min2.' '.$min3.' '.$min4.' '.$min5.' '.$min6.' 1 0 '.$outfolder.' '.$outfolder.' _cons_plus_gr\.fas';
	print "\n$find_ms3\n";
   system $find_ms3;

	if ($syst eq 'linux')
	{
   my $group_seq2 = 'perl group_seq_simple.pl '.$E_blast.' '.$blast_path.' '.$syst.' '.$outfolder.' '.$outfolder.' _nr_cons_plus_gr_mask\.fas';
	print "\n$group_seq2\n";
  system $group_seq2;
	}
	elsif ($syst eq 'win')
	{
   my $group_seq2 = 'perl group_seq_simple.pl '.$E_blast.' "'.$blast_path.'\" '.$syst.' '.$outfolder.' '.$outfolder.' _nr_cons_plus_gr_mask\.fas';
	print "\n$group_seq2\n";
  system $group_seq2;
	}

	my $pipe3 = $outfolder;
print "$pipe3\n";
	$pipe3 =~ s/pipe2/pipe3/;
	$pipe3 .= '.fas';
	if ($syst eq 'win')
	{
	    $pipe3 =~ s/.*\\//;
print "$pipe3\n";
		$copy = 'copy '.$outfolder.'\\'.$pipe3.' '.$folder.'\\data3\\';
		system $copy; 
	}
	if ($syst eq 'linux')
	{
	    $pipe3 =~  s/.*\///;
		$copy = 'cp '.$outfolder.'/'.$pipe3.' '.$folder.'/data3/';
		system $copy; 
	}
# end if (cons_calc)
}

#read all file in the outfolder and deletes then is unnecessary
unless ( opendir(FOLDER, $outfolder) )
{
      print "Cannot access to folder $folder\n";
      exit;
}
my @filenames_del = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);
my $file_orig = $tempfolder.'.fas';
foreach my $file (@filenames_del)
{
    if ($file eq 'clust' or $file eq $file_orig or $file =~ /pipe3\.fas/ or $file eq 'concat.fas.nin')
    {
	delete_win_linux($file, $outfolder, $syst);
    }
    elsif ($del_files == 1)
    {
	if ($file =~ /_mask\.fas/ or $file =~ /\.seq/ or $file =~ /_mask_short_final/ or $file=~ /_mask_cl\.txt/ or $file =~ /_mask_gr\.txt/ or $file =~ /cons_plus_gr\.fas/ or $file =~ /_nr_align/ or $file =~ /m8\.tbl/)
	{
	    delete_win_linux($file, $outfolder, $syst);
	}
    }
}



# end foreach file
}



##################
##################
##################
# copy output folders back into the original folder and delete c:\QDD_tetetemp
if ($syst eq 'win')
{
	check_and_delete_folder('c:\QDD_tetetemp\data2');

# check if no folder exists with the same name as the files to be analised (WO extesion)
	unless ( opendir(FOLDER, $orig_folder) )
	{
   	   print "Cannot access to folder $orig_folder\n";
  	    exit;
	}
	my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);

	unless ( opendir(FOLDER, 'c:\QDD_tetetemp') )
	{
   	   print "Cannot access to folder c:\\QDD_tetetemp\n";
  	    exit;
	}
	my @folders_to_move = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);

	check_and_rename_folder(\@folders_to_move, \@files, $orig_folder, $syst);

	$copy = 'xcopy "c:\QDD_tetetemp" "'.$orig_folder.'" /E /C /I /Y /Q';
	system $copy; 	
#DO NOT FIDDLE WITH THIS LINE!!!!! IT DELETES A FOLDER WITHOUT ASKING FOR COMFIRMATION
	check_and_delete_folder('c:\QDD_tetetemp');
}
##################
##################
##################

print "Analysis is finished";

if ($direct_par_def == 2)
{
	close(STDOUT);
	close(STDERR);
	open(STDOUT, ">&OLDOUT");
	open(STDERR, ">&OLDERR");
}
exit;

###################################

sub param_input
{
    my ($set_file,$del_files,$blast_path,$clust_path,$clust_ver,$gr_limit,$min1,$min2,$min3,$min4,$min5,$min6,$E_blast,$syst,$folder,$prop_maj,$cons_calc) = @_;

open(SET, $set_file);
my @setings = <SET>;

	if (scalar @setings == 0)
	{
		close SET;
		open_file_out($set_file, 'SET');
		open_file_in('set_pipe2_linux_backup.txt', 'SETL');
		my @par_backup = <SETL>;
		close SETL;
		foreach my $par (@par_backup)
		{
			print SET "$par";
		}
		close SET;
		open_file_in($set_file, 'SET');
		@setings = <SET>;
	}


$$del_files = $setings[0];
chomp $$del_files;
$$blast_path = $setings[1];
chomp $$blast_path;
$$clust_path = $setings[2];
chomp $$clust_path;
$$clust_ver = $setings[3];
chomp $$clust_ver;
$$gr_limit = $setings[4];
chomp $$gr_limit;
$$min1 = $setings[5];
chomp $$min1;
$$min2 = $setings[6];
chomp $$min2;
$$min3 = $setings[7];
chomp $$min3;
$$min4 = $setings[8];
chomp $$min4;
$$min5 = $setings[9];
chomp $$min5;
$$min6 = $setings[10];
chomp $$min6;
$$E_blast = $setings[11];
chomp $$E_blast;
$$syst = $setings[12];
chomp $$syst;
$$folder = $setings[13];
chomp $$folder;
$$prop_maj = $setings[14];
chomp $$prop_maj;
$$cons_calc = $setings[15];
chomp $$cons_calc;

close SET;


	my $reply = '';

    print "\n0: Operating system (win/linux): $$syst\n";
    print "1: Input folder: $$folder\n";
    print "2: Delete intermediate files (YES=1/NO=0): $$del_files\n";
    print "3: Make consensus sequences (YES=1/NO=0): $$cons_calc\n";	
    print "4: Maximum difference of flanking region alleles: $$gr_limit\n";
    print "5: Minimum number of monobase repetitions in MS masking: $$min1\n";
    print "6: Minimum number of dibase repetitions in MS maskin: $$min2\n";
    print "7: Minimum number of tribase repetitions in MS masking: $$min3\n";
    print "8: Minimum number of tetrabase repetitions in MS masking: $$min4\n";
    print "9: Minimum number of pentabase repetitions in MS masking: $$min5\n";
    print "10: Minimum number of hexabase repetitions in MS masking: $$min6\n";
    print "11: E value for all against all BLAST: $$E_blast\n";
    print "12: Proportion of sequences that must have the same base on the aligned site to accept it as a consensus: $$prop_maj\n";
    print "13: Pathway to BLAST: $$blast_path\n";
    print "14: Pathway to CLUSTALW: $$clust_path\n";
#    print "15: CLUSTALW version (1/2): $$clust_ver\n\n";

    print "Press enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";

    $reply = <STDIN>;

while ( not ($reply eq "\n"))
{
	open_file_out($set_file, 'SETOUT');


    if ($reply eq "\n")
    {
	print SETOUT "$$del_files\n$$blast_path\n$$clust_path\n$$clust_ver\n$$gr_limit\n$$min1\n$$min2\n$$min3\n$$min4\n$$min5\n$$min6\n$$E_blast\n$$syst\n$$prop_maj\n";
	next;
    }

    else
    {
	chomp $reply;

	if ($reply == 2)
	{
	    print "Do you wish to delete intermedite files? (YES=1/NO=0)\n";
	    $$del_files = <STDIN>;
	    chomp $$del_files;
	}
	elsif ($reply == 13)
	{
	    print "Enter the path to BLAST executables\n";
	    $$blast_path = <STDIN>;
	    chomp $$blast_path;
	}
	elsif ($reply == 14)
	{
	    print "Enter the path to CLUSTALW executables\n";
	    $$clust_path = <STDIN>;
	    chomp $$clust_path;
	}
#	elsif ($reply == 15)
#	{
#	    print "Enter the CLUSTALW version (1/2)\n";
#	    $$clust_ver = <STDIN>;
#	    chomp $$clust_ver;
#	}
	elsif ($reply == 4)
	{
	    print "Enter the maximum difference allowed between flanking regions of sequences that can be in the same contig\n";
	    $$gr_limit = <STDIN>;
	    chomp $$gr_limit;
	}
	elsif ($reply == 5)
	{
	    print "Enter the minimum number of mono-base repetitions in MS search\n";
	    $$min1= <STDIN>;
	    chomp $$min1;
	}
	elsif ($reply == 6)
	{
	    print "Enter the minimum number of di-base repetitions in MS search\n";
	    $$min2= <STDIN>;
	    chomp $$min2;
	}
	elsif ($reply == 7)
	{
	    print "Enter the minimum number of tri-base repetitions in MS search\n";
	    $$min3= <STDIN>;
	    chomp $$min3;
	}
	elsif ($reply == 8)
	{
	    print "Enter the minimum number of tetra-base repetitions in MS search\n";
	    $$min4= <STDIN>;
	    chomp $$min4;
	}
	if ($reply == 9)
	{
	    print "Enter the minimum number of penta-base repetitions in MS search\n";
	    $$min5= <STDIN>;
	    chomp $$min5;
	}
	elsif ($reply == 10)
	{
	    print "Enter the minimum number of hexa-base repetitions in MS search\n";
	    $$min6= <STDIN>;
	    chomp $$min6;
	}

	elsif ($reply == 11)
	{
	    print "Enter the E value for all against all BLAST\n";
	    $$E_blast= <STDIN>;
	    chomp $$E_blast;
	}
	elsif ($reply == 0 )
	{
	    print "Enter your operating system (win/linux)\n";
	    $$syst = <STDIN>;
	    chomp $$syst;
	}
	elsif ($reply == 1 )
	{
	    print "Enter your input folder\n";
	    $$folder = <STDIN>;
	    chomp $$folder;
	}
	elsif ($reply == 12 )
	{
	    print "Prortion of sequences that must have the same base on the aligned site to accept it as a consensus\n";
	    $$prop_maj = <STDIN>;
	    chomp $$prop_maj;
	}
	elsif ($reply == 3 )
	{
	    print "Do you want to make contigs and consensus sequences? (YES=1/NO=0, if 0 only unique sequence hit are used\n";
	    $$cons_calc = <STDIN>;
	    chomp $$cons_calc;
	}

	print SETOUT "$$del_files\n$$blast_path\n$$clust_path\n$$clust_ver\n$$gr_limit\n$$min1\n$$min2\n$$min3\n$$min4\n$$min5\n$$min6\n$$E_blast\n$$syst\n$$folder\n$$prop_maj\n$$cons_calc\n";

    print "\n0: Operating system (win/linux): $$syst\n";
    print "1: Input folder: $$folder\n";
    print "2: Delete intermediate files (YES=1/NO=0): $$del_files\n";
    print "3: Make consensus sequences (YES=1/NO=0): $$cons_calc\n";	
    print "4: Maximum difference of flanking region alleles: $$gr_limit\n";
    print "5: Minimum number of monobase repetitions in MS masking: $$min1\n";
    print "6: Minimum number of dibase repetitions in MS maskin: $$min2\n";
    print "7: Minimum number of tribase repetitions in MS masking: $$min3\n";
    print "8: Minimum number of tetrabase repetitions in MS masking: $$min4\n";
    print "9: Minimum number of pentabase repetitions in MS masking: $$min5\n";
    print "10: Minimum number of hexabase repetitions in MS masking: $$min6\n";
    print "11: E value for all against all BLAST: $$E_blast\n";
    print "12: Proportion of sequences that must have the same base on the aligned site to accept it as a consensus: $$prop_maj\n";
    print "13: Pathway to BLAST: $$blast_path\n";
    print "14: Pathway to CLUSTALW: $$clust_path\n";
 #   print "15: CLUSTALW version (1/2): $$clust_ver\n\n";

    print "Press enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";

	$reply = <STDIN>;

    }

    close SETOUT;
# end while ( not ($reply eq "\n"))
}
# end sub
}

